/* start.c */

/* Direttive */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#define ROW_LENGTH 256

typedef int boolean;
#define TRUE  1
#define FALSE 0


/* Prototipi delle procedure secondarie */
void GestisceCatalogo ();

boolean GestisceArticolo ();


/* Programma principale */
int main (int argc, char *argv[])
{
  /* Parte dichiarativa */


  /* Parte esecutiva */

  /* Converte il catalogo */
  GestisceCatalogo();

  return EXIT_SUCCESS;
}


/* Definizione delle procedure secondarie */

boolean GestisceArticolo ()
{
  /* Parte dichiarativa */
  char riga[ROW_LENGTH];
  char articolo[10+1];
  float prezzo;
  int giorno;
  char mese[9+1];
  int anno;
  int n;
  int m;

  /* Parte esecutiva */

  /* Acquisisce un articolo da tastiera */
  gets(riga);

  n = sscanf(riga,"%s %f %d %s %d",articolo,&prezzo,&giorno,mese,&anno);
  if ( (n == 1) && (strcmp(articolo,"STOP") == 0) ) return FALSE;
  if (n != 5)
  {
    fprintf(stderr,"Errore nei dati!\n");
    exit(EXIT_FAILURE);
  }

  /* Verifica la correttezza dei dati (se ne possono eseguire altre) */
  if ( (giorno <= 0) || (giorno > 31) )
  {
    fprintf(stderr,"Errore nei dati!\n");
    exit(EXIT_FAILURE);
  }

  /* Converte il mese da stringa a numero */
  if (strcmp(mese,"gennaio") == 0)
    m = 1;
  else if (strcmp(mese,"febbraio") == 0)
    m = 2;
  else if (strcmp(mese,"marzo") == 0)
    m = 3;
  else if (strcmp(mese,"aprile") == 0)
    m = 4;
  else if (strcmp(mese,"maggio") == 0)
    m = 5;
  else if (strcmp(mese,"giugno") == 0)
    m = 6;
  else if (strcmp(mese,"luglio") == 0)
    m = 7;
  else if (strcmp(mese,"agosto") == 0)
    m = 8;
  else if (strcmp(mese,"settembre") == 0)
    m = 9;
  else if (strcmp(mese,"ottobre") == 0)
    m = 10;
  else if (strcmp(mese,"novembre") == 0)
    m = 11;
  else if (strcmp(mese,"dicembre") == 0)
    m = 12;
  else
  {
    fprintf(stderr,"Errore nei dati!\n");
    exit(EXIT_FAILURE);
  }

  /* Stampa l'articolo nel formato richiesto */
  sprintf(riga,"%-10s%9.2f %02d/%02d/%04d",articolo,prezzo,giorno,m,anno);
  puts(riga);

  return TRUE;
}


void GestisceCatalogo (char *filedati)
{
  /* Parte dichiarativa */
  boolean risultato;


  /* Parte esecutiva */
  do {
    risultato = GestisceArticolo();
  } while (risultato == TRUE);
}
